# -*- coding: euc-jp -*-
module Thermo_Function  # Ǯϳؤ˴طؿ
  require "thermo_const.rb"
  include Thermo_Const
  require "phys_const.rb"
  include Phys_Const
  # Ǯϳѿ֤Ѵؿξ, "..2.."Ȥˤʤ.
  # ξ, 2 ƤΤ 2 θˤΤѴȤ
  # Ȥ̣Ƥ.

#----------------------------

def self.tetens(t)  # ƥƥμ¸Ѥ˰¿׻.
#  real, intent(in) :: T  # 絤β [K]
  a=7.5
  b=237.7
  c=9.5
  d=265.5
  t0=273.15

  if t<=t0 then
     tetens=E0*10.0**(c*(t-t0)/(t-t0+d))
  else
     tetens=E0*10.0**(a*(t-t0)/(t-t0+b))
  end

  return tetens
end

#-----------------------------------------------------
#-----------------------------------------------------

def self.es_Bolton(t)  # Bolton(1980) μˡѤ˰¿׻.
   
#  real, intent(in) :: T  # 絤β [K]
  t0=273.15
  a=17.67
  c=29.65

  es_Bolton=E0*exp(a*((t-t0)/(t-c)))

  return es_Bolton
end

#-----------------------------------------------------
#-----------------------------------------------------

def self.es_TD(e)  # es_Bolton Ѥ˰¿η׻εջ
# Ϫ٤׻.
#  real, intent(in) :: e  # 絤ο [Pa]
  t0=273.15
  a=17.67
  c=29.65

  es_TD=c+(a*(t0-c))/(a-log(e/E0))

  return es_TD
end

#-----------------------------------------------------
#-----------------------------------------------------

def self.lh(t)  #  T ˤǮη׻
  # ܴؿ, ǮȤη̤Ȥۤ礭ʺޤʤ.
  # ܷ׻, ǮβѲ˴ؤ֥ҥۥåդμפѤ.
  # ޤ, κݤɬפʱο갵Ǯӿ갵Ǯ
  # ٰ¸ʤΤȲꤷ, 줾
  # $C_l=4190,\; C_{pv}=1870$ȤͤѤƳФطǤ.
  # ä, ѤǮͤ䤽βٰ¸θȷѲǽ.
   
#  real, intent(in) :: T  # 絤β [K]
  t0=273.15

  lh=LH0-2.32e3*(t-t0)

  return lh
end

#-----------------------------------------------------
#-----------------------------------------------------

def self.eP_2_qv(e,p)  # 麮׻
#  real, intent(in) :: e  #  [Pa]
#  real, intent(in) :: P  # 絤 [Pa]

  eps=Rd/Rv
  eP_2_qv=eps*e/(p-e)

  return eP_2_qv
end

#-----------------------------------------------------
#-----------------------------------------------------

def self.tP_2_qvs(t,p)  # ٤˰º׻
  # Ǥ, es_Bolton Ѥ˰¿׻,
  # eP_2_qv ѤƺѴ뤳Ȥ˰º׻.
#  real, intent(in) :: T  #  [K]
#  real, intent(in) :: P  # 絤 [Pa]

  eps=Rd/Rv
  es=es_Bolton(t)
  tP_2_qvs=eps*es/(p-es)

  return tP_2_qvs
end

#-----------------------------------------------------
#-----------------------------------------------------

def self.qvP_2_e(qv,p)  # ׻
   
#  real, intent(in) :: qv  #  [kg / kg]
#  real, intent(in) :: P  #  [Pa]

  eps=Rd/Rv
  qvP_2_e=p*qv/(eps+qv)

  return qvP_2_e
end

#-----------------------------------------------------
#-----------------------------------------------------

def self.theta_dry(t,p)  # 絤ˤ벹̤׻
  # , 絤ˤƤ, ¬ P ȤƷ׻뤳ȤǤ
  # η̴̤ؿ theta_moist η̤ȤۤѤʤ.
   
#  real, intent(in) :: T  #  [K]
#  real, intent(in) :: P  # 絤ε(⤷, 絤) [Pa]

  kappa=Rd/Cpd
  theta_dry=t*(P0/p)**kappa

  return theta_dry
end

#-----------------------------------------------------
#-----------------------------------------------------

def self.theta_moist(t,p,qv)  # 絤ˤ벹̤׻
   
#  real, intent(in) :: T  #  [K]
#  real, intent(in) :: P  # 絤 [Pa]
#  real, intent(in) :: qv  #  [kg / kg]

  eps=Rd/Rv
  kappa=Rd/Cpd
  cr=Cpv/Cpd

  kappa=kappa*((1.0+qv/eps)/(1.0+qv*cr))  # kappa ͤ夫񤭤Ƥ뤳Ȥ
  theta_moist=t*(P0/p)**kappa

  return theta_moist
end

#-----------------------------------------------------
#-----------------------------------------------------

def self.thetaP_2_T(theta,p)  # , Ϥ鲹٤׻(絤ȤƷ׻)
   
#  real, intent(in) :: theta  #  [K]
#  real, intent(in) :: P  # 絤 [Pa]

  kappa=Rd/Cpd

  thetaP_2_T=theta*(p/P0)**kappa

  return thetaP_2_T
end

#-----------------------------------------------------
#-----------------------------------------------------

def self.thetaT_2_P(theta,t)  # , ٤鰵Ϥ׻(絤ȤƷ׻)
   
#  real, intent(in) :: theta  #  [K]
#  real, intent(in) :: T  #  [T]

  kappa=Cpd/Rd

  thetaT_2_P=P0*(t/theta)**kappa

  return theta_T_2_P
end

#-----------------------------------------------------
#-----------------------------------------------------

def self.tqvP_2_TLCL(t,qv,p)  ## ٤Ⱥ T_LCL ׻
  # 椫,  T_LCL ׻
   
#  real, intent(in) :: T  #  [K]
#  real, intent(in) :: qv  #  [kg / kg]
#  real, intent(in) :: P  #  [Pa]
  coe=2840.0
  a=3.5
  b=4.805
  c=55.0

  e=qvP_2_e(qv,p)
  e=e*1.0e-2
  tqvP_2_TLCL=coe/(a*log(t)-log(e)-b)+55.0

  return tqvP_2_TLCL
end

#-----------------------------------------------------
#-----------------------------------------------------

def self.thetae_Bolton(t,qv,p)  # Bolton(1980) ˤˡѤ̤׻.
  # T_LCL ѤΤ, ΤδؿѤ.
   
#  real, intent(in) :: T  #  [K]
#  real, intent(in) :: qv  #  [kg / kg]
#  real, intent(in) :: P  #  [Pa]
  a=0.2854
  b=0.28
  c=3376.0
  d=0.81

  t_LCL=tqvP_2_TLCL(t,qv,p)
  qvs=tP_2_qvs(t_LCL,p)
  thetae_Bolton=t*((P0/p)**(a*(1.0-b*qvs)))*exp((c/t_LCL-2.54)*qvs*(1.0+d*qvs))

  return thetae_Bolton
end

#-----------------------------------------------------
#-----------------------------------------------------

def self.thetaes_Bolton(t,p)  # Bolton(1980) ˤˡѤ˰̤׻.
   
#  real, intent(in) :: T  #  [K]
#  real, intent(in) :: P  #  [Pa]
  a=0.2854
  b=0.28
  c=3376.0
  d=0.81

  qvs=tP_2_qvs(t,p)
  thetaes_Bolton=t*((P0/p)**(a*(1.0-b*qvs)))*exp((c/t-2.54)*qvs*(1.0+d*qvs))

  return thetaes_Bolton
end

#-----------------------------------------------------
#-----------------------------------------------------

def self.tqvP_2_thetae(t,qv,p)  # , , ̤׻.
  # T_LCL ѤΤ, ΤδؿѤ.
   
#  real, intent(in) :: T  #  [K]
#  real, intent(in) :: qv  #  [kg / kg]
#  real, intent(in) :: P  #  [Pa]
  a=0.2854
  b=0.28
  c=3376.0
  d=0.81

  kappa=Rd/Cpd
  e=qvP_2_e(qv,p)
  t_LCL=tqvP_2_TLCL(t,qv,p)
  theta_d=t*(P0/(p-e))**kappa
  qvs=tP_2_qvs(t_LCL,p)
  tqvP_2_thetae=theta_d*exp(LH(t_LCL)*qvs/(Cpd*t_LCL))

  return tqvP_2_thetae
end

#-----------------------------------------------------
#-----------------------------------------------------

def self.tqvP_2_thetaes(t,p)  # , , ˰̤׻.
  # T_LCL ѤΤ, ΤδؿѤ.
   
#  real, intent(in) :: T  #  [K]
#  real, intent(in) :: P  #  [Pa]
  a=0.2854
  b=0.28
  c=3376.0
  d=0.81

  kappa=Rd/Cpd
  theta_d=t*(P0/p)**kappa
  qvs=tP_2_qvs(t,p)
  tqvP_2_thetaes=theta_d*exp(lh(t)*qvs/(Cpd*t))

  return tqvP_2_thetaes
end

#-----------------------------------------------------
#-----------------------------------------------------

def self.rhT_2_e(rh,t)  # м٤Ȳ٤׻
  # $RH=(e/es)\times 100$ Ȥ׻.
   
#  real, intent(in) :: RH  # м [%]
#  real, intent(in) :: T  #  [K]

  es=es_Bolton(t)
  rhT_2_e=rh*es*1.0e-2

  return rhT_2_e
end

#-----------------------------------------------------
#-----------------------------------------------------

def self.eT_2_RH(e,t)  # Ȳ٤м٤׻
  # $RH=(e/es)\times 100$ Ȥ׻.
   
#  real, intent(in) :: e  #  [Pa]
#  real, intent(in) :: T  #  [K]

  es=es_Bolton(t)
  eT_2_RH=100.0*e/es

  return eT_2_RH
end

#-----------------------------------------------------
#-----------------------------------------------------

def self.rhTP_2_qv(rh,t,p)  # м٤Ȳ٤麮׻
  # RHT_2_e ׻, eP_2_qv 麮׻.
   
#  real, intent(in) :: RH  # м [%]
#  real, intent(in) :: T  #  [K]
#  real, intent(in) :: P  #  [Pa]

  e=rhT_2_e(rh,t)
  rhTP_2_qv=eP_2_qv(e,p)

  return rhTP_2_qv
end

#-----------------------------------------------------
#-----------------------------------------------------

def self.qvTP_2_RH(qv,t,p)  # Ȳ٤м٤׻.
  # qvP_2_e ׻, м٤Ѥ.
   
#  real, intent(in) :: qv  # м [kg / kg]
#  real, intent(in) :: T  #  [K]
#  real, intent(in) :: P  #  [Pa]

  e=qvP_2_e(qv,p)
  qvTP_2_RH=eT_2_RH(e,t)

  return qvTP_2_RH
end

#-----------------------------------------------------
#-----------------------------------------------------

def self.exner_func_dry(p)  # 絤ˤĤƤΥʡؿ׻
   
#  real, intent(in) :: P  #  [Pa]

  kappa=Rd/Cpd
  exner_func_dry=(P0/p)**kappa

  return exner_func_dry
end

#-----------------------------------------------------
#-----------------------------------------------------

def self.hypsometric_form(p,z,t,z_t)  # ٤ȵͿƤ٤ε.
#  ιˤήˤɸ絤βٸΨǤ 6.5 [K/km] Ƿ׻.
   
#  real, intent(in) :: p  # Ȥʤ٤ˤ밵 [Pa]
#  real, intent(in) :: z  # Ȥʤ [m]
#  real, intent(in) :: T  # Ǥβ [K]
#  real, intent(in) :: z_t  #  [m]
  gam = 6.5e-3  # ɸ絤βٸΨ [K/m]

  z_calc=z_t

  p_tmp=p*((t+gam*z)/(t+gam*z_calc))**(G/(gam*Rd))
  hypsometric_form=p_tmp

  return hypsometric_form
end

#-----------------------------------------------------
#-----------------------------------------------------

def self.moist_laps_temp( p_stan, t_stan, p )
# Ǯˤ뼾ǮΨ˽,  p ˤ뵤ؿ.
# ϥѡε.
#  use Thermo_Const
#  implicit none
#  real, intent(in) :: p_stan  # ൤ɸ [Pa]
#  real, intent(in) :: T_stan  # ಹ [K]
#  real, intent(in) :: p  # ٤ˤ뵤 [Pa]
#  integer, intent(in), optional :: dl  # ǥХå٥
#  real :: seqpt, t_temp, seqpt_temp, dt, seqpt_temp2
#  integer, parameter :: ilim=20
#  real, parameter :: limit=2.0e-4

  limit=2.0e-4
  seqpt=thetaes_Bolton( t_stan, p_stan )
  seqpt_temp=thetaes_Bolton( t_stan, p )

  if p>p_stan then
     dt=1.0
  else
     dt=-1.0
  end

  t_temp=t_stan+dt
  seqpt_temp2=thetaes_Bolton( t_temp, p )

  while (seqpt_temp2-seqpt)*(seqpt_temp-seqpt) >0.0
     t_temp=t_temp+dt
     seqpt_temp=seqpt_temp2
     seqpt_temp2=thetaes_Bolton( t_temp, p )
  end

  seqpt_temp=seqpt_temp2
  dt=1.0

  while (seqpt_temp-seqpt).abs > limit

     dt=0.5*dt

     if( (seqpt_temp-seqpt)>0.0 )then
        t_temp=t_temp-dt
     else
        t_temp=t_temp+dt
     end

     seqpt_temp=thetaes_Bolton( t_temp, p )

  end

  moist_laps_temp=t_temp

  return moist_laps_temp

end

#-----------------------------------------------------
#-----------------------------------------------------

end
